/*
 * Ejercicio5.java
 *
 * Creado el 9 de diciembre de 2005, 11:48
 */


package computacion.practica2;

/**
 * Segn hemos demostrado tericamente (ver Ejercicio5.pdf)
 * el mtodo seno(x, n) aproxima a
 * sen x con n-1 cifras significativas siempre que  |x| <= 1 y
 * 1 <= n <= 14. Como vemos a continuacin, en la prctica la
 * aproximacin es bastante mejor.
 *
 * Aceptamos Math.sin(x) como valor exacto de sen x.
 *
 * @author Vctor Jimnez
 *
 * MTODOS NUMRICOS
 * LICENCIATURA DE MATEMTICAS
 * UNIVERSIDAD DE MURCIA
 */
public class Ejercicio5 {
    
    public static void main(String[] args) {
        double z;
        double s;
        double aux;
        int i;
                
        System.out.println();
        System.out.println("COMPARACIN ENTRE sen 0.5 Y seno(0.5, n)");
        System.out.println("n\t" + "sen 0.5\t\t\t" + "seno(0.5, n)\t\t"
                + "error relativo");
        for (int n = 1; n<= 13; n++) {
            System.out.println(n + "\t" + Math.sin(0.5) + "\t"
                    + seno(0.5, n) + "\t"
                    + errorRelativo(Math.sin(0.5), seno(0.5, n)));
        }
        System.out.println();
        System.out.println("COMPARACIN ENTRE sen 0.5 Y seno(0.5, 5E-13)");
        System.out.println("sen 0.5\t\t\t" + "seno(0.5, 5E-13)\t"
                + "error relativo");
        System.out.println(Math.sin(0.5) + "\t"
                + seno(0.5, 5E-13) + "\t"
                + errorRelativo(Math.sin(0.5), seno(0.5, 5E-13)));
        
        System.out.println();
        System.out.println("COMPARACIN ENTRE sen 0.005 Y seno(0.005, n)");
        System.out.println("n\t" + "sen 0.005\t\t" + "seno(0.005, n)\t\t"
                + "error relativo");
        for (int n = 1; n<= 13; n++) {
            System.out.println(n + "\t" + Math.sin(0.005) + "\t"
                    + seno(0.005, n) + "\t"
                    + errorRelativo(Math.sin(0.005), seno(0.005, n)));
        }
        System.out.println();
        System.out.println("COMPARACIN ENTRE sen 0.005 Y seno(0.005, 5E-13)");
        System.out.println("sen 0.005\t\t" + "seno(0.005, 5E-13)\t"
                + "error relativo");
        System.out.println(Math.sin(0.005) + "\t"
                + seno(0.005, 5E-13) + "\t"
                + errorRelativo(Math.sin(0.005), seno(0.005, 5E-13)));
        
        System.out.println();
        System.out.println("COMPARACIN ENTRE sen 500 Y seno(500, n)");
        System.out.println("n\t" + "sen 500\t\t\t" + "seno(500, n)\t\t"
                + "error relativo");
        for (int n = 1; n<= 13; n++) {
            System.out.println(n + "\t" + Math.sin(500) + "\t"
                    + seno(500, n) + "\t"
                    + errorRelativo(Math.sin(500), seno(500, n)));
        }
        System.out.println();
        System.out.println("COMPARACIN ENTRE sen 500 Y seno(500, 5E-13)");
        System.out.println("sen 500\t\t\t" + "seno(500, 5E-13)\t"
                + "error relativo");
        System.out.println(Math.sin(500) + "\t"
                + seno(500, 5E-13) + "\t"
                + errorRelativo(Math.sin(500), seno(500, 5E-13)));
        
        System.out.println();
        System.out.println("ES IMPORTANTE ACOTAR EL NMERO CUYO SENO "
                + "QUIERE CALCULARSE!");
        z = 500;
        s = 500;
        aux = 500;
        i = 1;
        while (errorRelativo(s, s - aux) >= 5E-13) {
            i = i + 1;
            aux = - aux * z / (2 * i - 2) * z / (2 * i - 1);
            s = s + aux;
        }
        System.out.println("sen 500 calculado directamente sumando " +  i
                + " trminos no nulos: " + s);           
    }
    
    public static double errorRelativo (double real, double aprox) {
        return Math.abs((real - aprox) / real);
    }
    
    /**
     * Primera versin del mtodo seno. El nmero de sumandos viene
     * determinado por n.
     */
    public static double seno(double x, int n) {
        double y;
        double z;
        double s;
        double aux;
        
        /**
         * Dado x, calculamos un valor y en [-PI/2, PI/2] tal que
         * sen x = sen y
         */
        y = x - 2 * Math.PI * Math.floor((x + Math.PI) / (2 * Math.PI));
        if (y > Math.PI / 2) {
            y = Math.PI - y;
        } else if (y < - Math.PI / 2) {
            y = - Math.PI - y;
        }
        if (Math.abs(y) > 1) {
            z = y / 2;
        } else {
            z = y;
        }
        
        /**
         * Ahora calculamos sen z para z = y si |y| <= 1
         * y para z = y/2 si |y| > 1, sumando los n primeros trminos
         * de la serie de potencias que define sen x
         */
        s = z;
        aux = z;
        for (int i = 2; i <= n; i++) {
            aux = - aux * z / (2 * i - 2) * z / (2 * i - 1);
            s = s + aux;
        }
        
        /**
         * Ahora calculamos sen x = sen y en funcin de sen z usando la frmula
         * sen y = (1 - (1 - 2 sen^2 z)^{1/2} para el caso z = y/2
         */
        if (y > 1) {
            s = Math.sqrt(1 - Math.pow(1 - 2 * Math.pow(s, 2), 2));
        }
        if (y < - 1) {
            s = - Math.sqrt(1 - Math.pow(1 - 2 * Math.pow(s, 2), 2));
        }
        return s;
    }
    
    /**
     * Segunda versin del mtodo seno. El nmero de sumandos se determina
     * en funcin de la precisin requerida
     */
    public static double seno(double x, double prec) {
        double y;
        double z;
        double s;
        double aux;
        int i;
        
        /**
         * Dado x, calculamos un valor y en [-PI/2, PI/2] tal que
         * sen x = sen y
         */
        y = x - 2 * Math.PI * Math.floor((x + Math.PI) / (2 * Math.PI));        
        if (y > Math.PI / 2) {
            y = Math.PI - y;
        } else if (y < - Math.PI / 2) {
            y = - Math.PI - y;
        }
        if (Math.abs(y) > 1) {
            z = y / 2;
        } else {
            z = y;
        }
        
        /**
         * Ahora calculamos sen z para z = y si |y| <= 1
         * y para z = y/2 si |y| > 1, sumando trminos hasta que la variacin
         * relativa al sumar un nuevo trmino es inferior a prec
         */
        s = z;
        if (s == 0) {
            return s;
        }
        aux = z;
        i = 1;
        while (errorRelativo(s, s - aux) >= prec) {
            i = i + 1;
            aux = - aux * z / (2 * i - 2) * z / (2 * i - 1);
            s = s + aux;
        }
        
        /**
         * Ahora calculamos sen x = sen y en funcin de sen z usando la frmula
         * sen y = (1 - (1 - 2 sen^2 z)^{1/2} para el caso z = y/2
         */
        if (y > 1) {
            s = Math.sqrt(1 - Math.pow(1 - 2 * Math.pow(s, 2), 2));
        }
        if (y < - 1) {
            s = - Math.sqrt(1 - Math.pow(1 - 2 * Math.pow(s, 2), 2));
        }
        return s;
    }
    
}
