/*
 * Ejercicio8.java
 *
 * Creado el 1 de octubre de 2007, 11:21
 */


package computacion.practica2;

/**
 *
 * @author Vctor Jimnez
 *
 * MTODOS NUMRICOS
 * LICENCIATURA DE MATEMTICAS
 * UNIVERSIDAD DE MURCIA
 */
public class Ejercicio8 {
    
    /**
     * La presente prctica ilustra cmo el orden en que se realicen las 
     * operaciones puede modificar el error en los clculos (cuanto ms grandes
     * son los nmeros que se manejan, mayor es el error).
     *
     * En el caso x = -2, el primer mtodo de clculo es ms efectivo (porque
     * aunque el sumatorio en sumaExp(-2, k) es ms pequeo que
     * el de invsumExp(-2, k), el incremento del error en el segundo caso
     * se compensa al dividir 1 por el sumatorio y retornarse 
     * a un nmero pequeo.  En el caso x = 5 ocurre a la inversa; la divisin 
     * dentro de invsumExp(5, k) por un nmero pequeo incrementa el error. 
     */
    public static void main(String[] args) {
        double x;
        
        x = -2;
        System.out.println("Aproximacin de exp(-2):");
        System.out.println("k \tsumaExp \t\terror sumaExp \t\tinvsumaExp" +
                "\t\terror invSumaExp");
        for (int k = 0; k <= 30; k++) {
            System.out.println(
                    k + "\t" + sumaExp(x, k) + "\t" +
                    Math.abs(Math.exp(x) - sumaExp(x, k)) + "\t" +
                    invsumaExp(x, k) + "\t" +
                    Math.abs(Math.exp(x) - invsumaExp(x, k))
                    );
        }
        
        System.out.println("");
        x = 5;
        System.out.println("Aproximacin de exp(5):");
        System.out.println("k \tsumaExp \t\terror sumaExp \t\tinvsumaExp" +
                "\t\terror invSumaExp");
        for (int k = 0; k <= 30; k++) {
            System.out.println(
                    k + "\t" + sumaExp(x, k) + "\t" +
                    Math.abs(Math.exp(x) - sumaExp(x, k)) + "\t" +
                    invsumaExp(x, k) + "\t" +
                    Math.abs(Math.exp(x) - invsumaExp(x, k))
                    );
        }
        
        
        
    }
    
    public static double sumaExp(double x, int k) {
        double suma;
        double factor;
                
        /**
         * Ntese que el la cuenta de abajo conviene evitar calcular el 
         * factorial de un numero aparte pues enseguida toma valores muy
         * grandes con el consiguiente incremento del error.
         */
        suma = 1;
        factor = 1;        
        for (int i = 1; i <= k; i++) {
            factor = factor / i * x;
            suma = suma + factor;            
        }
        return suma;
    }
    
    public static double invsumaExp(double x, int k) {
        double suma;
        double factor;
        
        suma = 1;
        factor = 1;
        for (int i = 1; i <= k; i++) {
            factor = - factor / i * x;
            suma = suma + factor;
        }
        suma = 1 / suma;
        return suma;
    }
}
