/*
 * Ejercicio4.java
 *
 * Creado el 20 de abril de 2006, 12:54
 */


package metodosLineales.practica5;
import auxiliar.*;
import javax.swing.*;

/**
 * La estructura del sistema Ax = b a resolver se describe en un pdf adjunto.
 * Hemos resuelto el problema en general, es decir, permitiendo una
 * cuadrcula de tamao arbitrario y que las temperaturas en los bordes se
 * puedan elegir. Para ms detalles ver el fichero anexo.
 * 
 * @author Vctor Jimnez, Mara Jos Cano Vicente
 * 
 * MTODOS NUMRICOS
 * LICENCIATURA DE MATEMTICAS
 * UNIVERSIDAD DE MURCIA
 */
public class Ejercicio4 {
    
    public static void main(String[] args) {
        int h = 5;
        int dim = 25;
        double arriba = 100;
        double izda = 0;
        double dcha = 50;
        double abajo = 0;
        int resp;
        String aux;
        boolean datosErroneos;
        double[][] A;
        double[][] T;
        double[][] J;
        double[] b;
        double[] sol;
        double[] r;
        double norm;
        
        /**
         * Se ofrece la posibilidad de usar los datos del programa o
         * introducirlos desde fuera del mismo
         */
        resp = JOptionPane.showConfirmDialog(null,
                "Utilizar los datos del problema?",
                "Pregunta", JOptionPane.YES_NO_OPTION);
        if (resp != JOptionPane.YES_OPTION) {
            
            /* Pedimos el tamao de la cuadrcula */
            datosErroneos = true;
            while (datosErroneos) {
                try {
                    datosErroneos = false;
                    aux = JOptionPane.showInputDialog(
                            "Introduce el tamao de la cuadrcula");
                    h = Integer.parseInt(aux);
                    if (h <= 0) { // comprobamos que la dimensin sea adecuada
                        JOptionPane.showMessageDialog(null,
                                "Error: tamao entero pero no positivo");
                        datosErroneos = true;
                    }
                } catch(Exception errDatos) {
                    datosErroneos = true;
                    JOptionPane.showMessageDialog(null,
                            "Error: tamao no entero");
                }
            }
            dim = h * h;
            
            /* Pedimos el valor de la temperatura arriba */
            datosErroneos = true;
            while (datosErroneos) {
                try {
                    datosErroneos = false;
                    aux = JOptionPane.showInputDialog("Introduce "
                            + "el valor de arriba");
                    arriba = Double.parseDouble(aux);
                } catch(Exception errDatos) {
                    datosErroneos = true;
                    JOptionPane.showMessageDialog(null,
                            "Error: nmero no real");
                }
            }
            
            /* Pedimos el valor de la temperatura a la izquierda */
            datosErroneos = true;
            while (datosErroneos) {
                try {
                    datosErroneos = false;
                    aux = JOptionPane.showInputDialog("Introduce "
                            + "el valor de la izquierda");
                    izda = Double.parseDouble(aux);
                } catch(Exception errDatos) {
                    datosErroneos = true;
                    JOptionPane.showMessageDialog(null,
                            "Error: nmero no real");
                }
            }
            
            /* Pedimos el valor de la temperatura a la derecha */
            datosErroneos = true;
            while (datosErroneos) {
                try {
                    datosErroneos = false;
                    aux = JOptionPane.showInputDialog("Introduce "
                            + "el valor de la derecha");
                    dcha = Double.parseDouble(aux);
                } catch(Exception errDatos) {
                    datosErroneos = true;
                    JOptionPane.showMessageDialog(null,
                            "Error: nmero no real");
                }
            }
            
            /* Pedimos el valor de la temperatura abajo */
            datosErroneos = true;
            while (datosErroneos) {
                try {
                    datosErroneos = false;
                    aux = JOptionPane.showInputDialog("Introduce "
                            + "el valor de abajo");
                    abajo = Double.parseDouble(aux);
                } catch(Exception errDatos) {
                    datosErroneos = true;
                    JOptionPane.showMessageDialog(null,
                            "Error: nmero no real");
                }
            }
        }
               
        if (h == 1) { // descartamos el caso trivial h = 1
             System.out.println();
             System.out.println("La solucin es: " 
                     + ((arriba + izda + dcha + abajo) / 4) );
        } else {
            
            /* Definimos la matriz A del sistema */
            A = new double[dim][dim];
            T = new double[h][h];
            J = new double[h][h];
            
            /* Definimos las matrices T y J */
            for(int i = 0; i < h; i++) {
                for(int j = 0; j < h; j++) {
                    if(i == j) {
                        J[i][j] = -1;
                    } else J[i][j] = 0;
                }
            }
            for(int i = 0; i < h; i++) {
                for(int j = 0; j < h; j++) {
                    if(i == j) {
                        T[i][j] = 4;
                    } else if (Math.abs(i - j) == 1) {
                        T[i][j] = -1;
                    } else {
                        T[i][j] = 0;
                    }
                }
            }
            
            /* Construimos A usando los bloques T y J */
            for(int k = 0; k < h; k++) {
                for(int i = 0; i < h; i++) {
                    for(int j = 0; j < h; j++) {
                        A[k * h + i][k * h + j] = T[i][j];
                    }
                }
            }
            for(int k = 0; k < h - 1; k++) {
                for(int i = 0; i < h; i++) {
                    for(int j = 0; j < h; j++) {
                        A[(k + 1) * h + i][k * h + j] = J[i][j];
                        A[k * h + i][(k + 1) * h + j] = J[i][j];
                    }
                }
            }
            System.out.println();
            System.out.println("La matriz A del sistema a resolver es:");
            System.out.println(Matrices.toString(A));
            
            /* Definimos el trmino independiente b */
            b = new double[dim];
            for(int m = 1; m < h - 1; m++) {
                b[m] = arriba;
            }
            for(int m = 1; m < h - 1; m++) {
                b[m * h] = izda;
            }
            for(int m = 1; m < h - 1; m++) {
                b[m * h + (h - 1)] = dcha;
            }
            for(int m = 1; m < h - 1; m++) {
                b[h * (h - 1) + m] = abajo;
            }
            b[0] = arriba + izda;
            b[h - 1] = arriba + dcha;
            b[h * (h - 1)] = abajo + izda;
            b[h * h - 1] = abajo + dcha;
            System.out.println();
            System.out.println("El trmino independiente b del sistema " 
                    + "a resolver es:");
            System.out.println(Matrices.toString(b));
            
            /* Resolvemos el sistema usando el mtodo de Gauss total */
            sol = new double[dim];
            r = new double[dim];
            norm = 0;
            try {
                sol = Matrices.gaussTotal(A, b);
                System.out.println();
                System.out.println("La solucin del sistema con gaussTotal es:");
                System.out.println(Matrices.toString(sol));
                r = Matrices.resta(b, Matrices.producto(A, sol));
                norm = Matrices.norma(r);
                System.out.println();
                System.out.println("sta es la norma de r = b - Ax: " + norm);
            } catch(Matrices.ErrorMetodosLineales err) {
            }
        }
        System.exit(0);
    }
    
}
